import AssignmentCanvasOverride from './CanvasAssignmentOverride';
import CanvasDiscussionTopic from './CanvasDiscussionTopic';
import CanvasRubricCriterion from './CanvasRubricCriterion';
import CanvasRubricSettings from './CanvasRubricSettings';
import CanvasSubmission from './CanvasSubmission';
interface CanvasAssignment {
    id: number;
    name: string;
    description: string;
    created_at: string;
    updated_at?: string;
    due_at?: string | null;
    lock_at?: string | null;
    unlock_at?: string | null;
    has_overrides?: boolean | null;
    all_dates?: any | null;
    course_id: number;
    html_url: string;
    submissions_download_url: string;
    assignment_group_id?: number | null;
    due_date_required: boolean;
    allowed_extensions?: string[] | null;
    max_name_length: number;
    turnitin_enabled?: boolean | null;
    vericite_enabled?: boolean | null;
    turnitin_settings?: any | null;
    grade_group_students_individually?: boolean | null;
    external_tool_tag_attributes?: any | null;
    peer_reviews?: boolean | null;
    automatic_peer_reviews?: boolean | null;
    peer_review_count?: number | null;
    peer_reviews_assign_at?: string | null;
    intra_group_peer_reviews?: boolean | null;
    group_category_id?: number | null;
    needs_grading_count?: number | null;
    needs_grading_count_by_section: ({
        section_id: string;
        needs_grading_count: number;
    })[];
    position: number;
    post_to_sis?: boolean | null;
    integration_id?: string | null;
    integration_data?: any | null;
    points_possible?: number | null;
    submission_types: ('discussion_topic' | 'online_quiz' | 'on_paper' | 'none' | 'external_tool' | 'online_text_entry' | 'online_url' | 'online_upload' | 'media_recording' | 'student_annotation')[];
    has_submitted_submissions?: boolean | null;
    grading_type: ('pass_fail' | 'percent' | 'letter_grade' | 'gpa_scale' | 'points');
    grading_standard_id?: number | null;
    published: boolean;
    unpublishable: boolean;
    only_visible_to_overrides: boolean;
    locked_for_user: boolean;
    lock_info?: any | null;
    lock_explanation?: string | null;
    quiz_id?: number | null;
    anonymous_submissions?: boolean | null;
    discussion_topic?: CanvasDiscussionTopic | null;
    freeze_on_copy?: boolean | null;
    frozen?: boolean | null;
    frozen_attributes?: string[] | null;
    submission?: CanvasSubmission | null;
    use_rubric_for_grading?: boolean | null;
    rubric_settings?: CanvasRubricSettings | null;
    rubric?: CanvasRubricCriterion[] | null;
    assignment_visibility?: number[] | null;
    overrides?: AssignmentCanvasOverride[] | null;
    omit_from_final_grade?: boolean | null;
    moderated_grading?: boolean | null;
    grader_count: number;
    final_grader_id?: number | null;
    grader_comments_visible_to_graders: boolean;
    graders_anonymous_to_graders: boolean;
    grader_names_visible_to_final_grader: boolean;
    anonymous_grading: boolean;
    allowed_attempts: number;
    post_manually: boolean;
    score_statistics?: boolean | null;
    can_submit?: boolean | null;
    annotatable_attachment_id?: any | null;
}
export default CanvasAssignment;
