interface CanvasQuiz {
    id: number;
    title: string;
    html_url: string;
    mobile_url: string;
    preview_url: string;
    description: string;
    quiz_type: ('practic_quiz' | 'assignment' | 'graded_survey' | 'survey');
    assignment_group_id?: number;
    time_limit?: number | null;
    shuffle_answers?: boolean | null;
    hide_results?: ('always' | 'until_after_last_attempt' | null);
    show_correct_answers?: boolean | null;
    show_correct_answers_last_attempt?: boolean | null;
    show_correct_answers_at?: string | null;
    hide_correct_answers_at?: string | null;
    one_time_results?: boolean | null;
    scoring_policy?: ('keep_highest' | 'keep_latest') | null;
    allowed_attempts: number;
    one_question_at_a_time?: boolean | null;
    question_count: number;
    points_possible: number;
    cant_go_back?: boolean | null;
    access_code?: string | null;
    ip_filter?: string | null;
    due_at?: string | null;
    lock_at?: string | null;
    unlock_at?: string | null;
    published?: boolean | null;
    unpublishable?: boolean | null;
    locked_for_user?: boolean | null;
    lock_info?: any | null;
    lock_explanation?: string | null;
    speedgrader_url?: string | null;
    quiz_extensions_url?: string | null;
    permissions?: {
        read: boolean;
        submit: boolean;
        create: boolean;
        manage: boolean;
        read_statistics: boolean;
        review_grades: boolean;
        update: boolean;
    };
    all_dates?: any | null;
    version_number: number;
    question_types: string[];
    anonymous_submissions?: boolean | null;
}
export default CanvasQuiz;
