import CanvasAssignment from './CanvasAssignment';
import CanvasCourse from './CanvasCourse';
import CanvasRubricAssessment from './CanvasRubricAssessment';
import CanvasSubmissionComment from './CanvasSubmissionComment';
import CanvasUser from './CanvasUser';
interface CanvasSubmission {
    assignment_id: number;
    assignment?: CanvasAssignment | null;
    course?: CanvasCourse | null;
    attempt?: number | null;
    body?: string | null;
    grade?: string | null;
    grade_matches_current_submission?: boolean | null;
    html_url: string;
    preview_url: string;
    score: number;
    submission_comments?: CanvasSubmissionComment[] | null;
    submission_type: ('online_text_entry' | 'online_url' | 'online_upload' | 'media_recording' | 'student_annotation');
    submitted_at?: string | null;
    url?: string | null;
    user_id: number;
    grader_id?: number | null;
    graded_at: "2012-01-02T03:05:34Z";
    user?: CanvasUser | null;
    late?: boolean | null;
    assignment_visible?: boolean | null;
    excused?: boolean | null;
    missing?: boolean | null;
    late_policy_status?: ('late' | 'missing' | 'none' | null);
    points_deducted?: number | null;
    seconds_late: number;
    workflow_state: string;
    extra_attempts?: number | null;
    anonymous_id?: string | null;
    posted_at?: string | null;
    read_status?: string | null;
    rubric_assessment?: CanvasRubricAssessment | null;
}
export default CanvasSubmission;
